package NET.worlds.scape;

import java.util.Enumeration;
import java.util.Vector;

public class CollapsePortal extends Action implements NonPersister {
    public Persister trigger(Event event, Persister persister) {
        SuperRoot owner = getOwner();
        if(!(owner instanceof Portal)) return null;
        Portal portal = (Portal)owner;
        Portal farPortal = portal.farSide();
        Room room = getRoom();
        RoomEnvironment environment = room.getEnvironment();
        Room farRoom = portal.farSideRoom();
        Enumeration farContents = farRoom.getContents();
        Vector farContentsVector = new Vector();
        while(farContents.hasMoreElements()) {
            farContentsVector.add(farContents.nextElement());
        }
        Enumeration farContentsVectorEnum = farContentsVector.elements();
        while(farContentsVectorEnum.hasMoreElements()) {
            WObject item = (WObject)farContentsVectorEnum.nextElement();
            item.detach();
            room.add(item);
            item.moveBy(farPortal.invert().getPosition());
            Point3Temp farSpinAxis = Point3Temp.make();
            Point3Temp spinAxis = Point3Temp.make();
            float farSpinAngle = farPortal.getSpin(farSpinAxis);
            item.spin(farSpinAxis, -farSpinAngle);
            float spinAngle = portal.getSpin(spinAxis);
            item.spin(spinAxis, spinAngle);
            item.moveBy(portal.getPosition());
        }
        Enumeration farEnvContents = farRoom.getEnvironment().getContents();
        Vector farEnvContentsVector = new Vector();
        while(farEnvContents.hasMoreElements()) {
            farEnvContentsVector.add(farEnvContents.nextElement());
        }
        Enumeration farEnvContentsVectorEnum = farEnvContentsVector.elements();
        while(farEnvContentsVectorEnum.hasMoreElements()) {
            WObject item = (WObject)farEnvContentsVectorEnum.nextElement();
            if(item != farPortal) {
                item.detach();
                environment.add(item);
                item.moveBy(farPortal.invert().getPosition());
                Point3Temp farSpinAxis = Point3Temp.make();
                Point3Temp spinAxis = Point3Temp.make();
                float farSpinAngle = farPortal.getSpin(farSpinAxis);
                item.spin(farSpinAxis, -farSpinAngle);
                float spinAngle = portal.getSpin(spinAxis);
                item.spin(spinAxis, spinAngle);
                item.moveBy(portal.getPosition());
            }
        }
        return null;
    }
}